2019-10-01 14:24:27

by Haishuang Yan

[permalink] [raw]
Subject: [PATCH v3 0/3] selftests: netfilter: introduce test cases for ipvs

This series patch include test cases for ipvs.

The test topology is who as below:
+--------------------------------------------------------------+
| | |
| ns0 | ns1 |
| ----------- | ----------- ----------- |
| | veth01 | --------- | veth10 | | veth12 | |
| ----------- peer ----------- ----------- |
| | | | |
| ----------- | | |
| | br0 | |----------------- peer |--------------|
| ----------- | | |
| | | | |
| ---------- peer ---------- ----------- |
| | veth02 | --------- | veth20 | | veth12 | |
| ---------- | ---------- ----------- |
| | ns2 |
| | |
+--------------------------------------------------------------+

Test results:
# selftests: netfilter: ipvs.sh
# Testing DR mode...
# Testing NAT mode...
# Testing Tunnel mode...
# ipvs.sh: PASS
ok 6 selftests: netfilter: ipvs.sh

Haishuang Yan (3):
selftests: netfilter: add ipvs test script
selftests: netfilter: add ipvs nat test case
selftests: netfilter: add ipvs tunnel test case

tools/testing/selftests/netfilter/Makefile | 2 +-
tools/testing/selftests/netfilter/ipvs.sh | 234 +++++++++++++++++++++++++++++
2 files changed, 235 insertions(+), 1 deletion(-)
create mode 100755 tools/testing/selftests/netfilter/ipvs.sh

--
1.8.3.1




2019-10-01 14:24:41

by Haishuang Yan

[permalink] [raw]
Subject: [PATCH v3 2/3] selftests: netfilter: add ipvs nat test case

Test virtual server via NAT.

Tested:
# selftests: netfilter: ipvs.sh
# Testing DR mode...
# Testing NAT mode...
# ipvs.sh: PASS

Signed-off-by: Haishuang Yan <[email protected]>
---
tools/testing/selftests/netfilter/ipvs.sh | 22 +++++++++++++++++++++-
1 file changed, 21 insertions(+), 1 deletion(-)

diff --git a/tools/testing/selftests/netfilter/ipvs.sh b/tools/testing/selftests/netfilter/ipvs.sh
index 6201046..270b5da 100755
--- a/tools/testing/selftests/netfilter/ipvs.sh
+++ b/tools/testing/selftests/netfilter/ipvs.sh
@@ -160,20 +160,40 @@ test_dr() {
test_service
}

+test_nat() {
+ ip netns exec ns0 ip route add ${vip_v4} via ${gip_v4} dev br0
+
+ ip netns exec ns1 sysctl -qw net.ipv4.ip_forward=1
+ ip netns exec ns1 ipvsadm -A -t ${vip_v4}:${port} -s rr
+ ip netns exec ns1 ipvsadm -a -m -t ${vip_v4}:${port} -r ${rip_v4}:${port}
+ ip netns exec ns1 ip addr add ${vip_v4}/32 dev lo:1
+
+ ip netns exec ns2 ip link del veth20
+ ip netns exec ns2 ip route add default via ${dip_v4} dev veth21
+
+ test_service
+}
+
run_tests() {
local errors=

echo "Testing DR mode..."
+ cleanup
setup
test_dr
errors=$(( $errors + $? ))

+ echo "Testing NAT mode..."
+ cleanup
+ setup
+ test_nat
+ errors=$(( $errors + $? ))
+
return $errors
}

trap cleanup EXIT

-cleanup
run_tests

if [ $? -ne 0 ]; then
--
1.8.3.1



2019-10-01 14:28:10

by Haishuang Yan

[permalink] [raw]
Subject: [PATCH v3 1/3] selftests: netfilter: add ipvs test script

Test virutal server via directing routing for IPv4.

Tested:

# selftests: netfilter: ipvs.sh
# Testing DR mode...
# ipvs.sh: PASS
ok 6 selftests: netfilter: ipvs.sh

Signed-off-by: Haishuang Yan <[email protected]>
---
v3: use bash style
v2: optimize test script
---
tools/testing/selftests/netfilter/Makefile | 2 +-
tools/testing/selftests/netfilter/ipvs.sh | 184 +++++++++++++++++++++++++++++
2 files changed, 185 insertions(+), 1 deletion(-)
create mode 100755 tools/testing/selftests/netfilter/ipvs.sh

diff --git a/tools/testing/selftests/netfilter/Makefile b/tools/testing/selftests/netfilter/Makefile
index 4144984..de1032b 100644
--- a/tools/testing/selftests/netfilter/Makefile
+++ b/tools/testing/selftests/netfilter/Makefile
@@ -2,6 +2,6 @@
# Makefile for netfilter selftests

TEST_PROGS := nft_trans_stress.sh nft_nat.sh bridge_brouter.sh \
- conntrack_icmp_related.sh nft_flowtable.sh
+ conntrack_icmp_related.sh nft_flowtable.sh ipvs.sh

include ../lib.mk
diff --git a/tools/testing/selftests/netfilter/ipvs.sh b/tools/testing/selftests/netfilter/ipvs.sh
new file mode 100755
index 0000000..6201046
--- /dev/null
+++ b/tools/testing/selftests/netfilter/ipvs.sh
@@ -0,0 +1,184 @@
+#!/bin/bash
+# SPDX-License-Identifier: GPL-2.0
+#
+# End-to-end ipvs test suite
+# Topology:
+#--------------------------------------------------------------+
+# | |
+# ns0 | ns1 |
+# ----------- | ----------- ----------- |
+# | veth01 | --------- | veth10 | | veth12 | |
+# ----------- peer ----------- ----------- |
+# | | | |
+# ----------- | | |
+# | br0 | |----------------- peer |--------------|
+# ----------- | | |
+# | | | |
+# ---------- peer ---------- ----------- |
+# | veth02 | --------- | veth20 | | veth21 | |
+# ---------- | ---------- ----------- |
+# | ns2 |
+# | |
+#--------------------------------------------------------------+
+#
+# We assume that all network driver are loaded
+#
+
+# Kselftest framework requirement - SKIP code is 4.
+ksft_skip=4
+ret=0
+GREEN='\033[0;92m'
+RED='\033[0;31m'
+NC='\033[0m' # No Color
+
+readonly port=8080
+
+readonly vip_v4=207.175.44.110
+readonly cip_v4=10.0.0.2
+readonly gip_v4=10.0.0.1
+readonly dip_v4=172.16.0.1
+readonly rip_v4=172.16.0.2
+readonly sip_v4=10.0.0.3
+
+readonly infile="$(mktemp)"
+readonly outfile="$(mktemp)"
+
+sysipvsnet=/proc/sys/net/ipv4/vs/
+if [ ! -d /proc/sys/net/ipv4/vs/ ]; then
+ modprobe -q ip_vs
+ if [ $? -ne 0 ]; then
+ echo "SKIP: Could not run test without ipvs module"
+ exit $ksft_skip
+ fi
+fi
+
+ip -Version > /dev/null 2>&1
+if [ $? -ne 0 ]; then
+ echo "SKIP: Could not run test without ip tool"
+ exit $ksft_skip
+fi
+
+ipvsadm -v > /dev/null 2>&1
+if [ $? -ne 0 ]; then
+ echo "SKIP: Could not run test without ipvsadm"
+ exit $ksft_skip
+fi
+
+nc --version > /dev/null 2>&1
+if [ $? -ne 0 ]; then
+ echo "SKIP: Could not run test without ncat"
+ exit $ksft_skip
+fi
+
+setup() {
+ ip netns add ns0
+ ip netns add ns1
+ ip netns add ns2
+
+ ip link add veth01 netns ns0 type veth peer name veth10 netns ns1
+ ip link add veth02 netns ns0 type veth peer name veth20 netns ns2
+ ip link add veth12 netns ns1 type veth peer name veth21 netns ns2
+
+ ip netns exec ns0 ip link set veth01 up
+ ip netns exec ns0 ip link set veth02 up
+ ip netns exec ns0 ip link add br0 type bridge
+ ip netns exec ns0 ip link set veth01 master br0
+ ip netns exec ns0 ip link set veth02 master br0
+ ip netns exec ns0 ip link set br0 up
+ ip netns exec ns0 ip addr add ${cip_v4}/24 dev br0
+
+ ip netns exec ns1 ip link set lo up
+ ip netns exec ns1 ip link set veth10 up
+ ip netns exec ns1 ip addr add ${gip_v4}/24 dev veth10
+ ip netns exec ns1 ip link set veth12 up
+ ip netns exec ns1 ip addr add ${dip_v4}/24 dev veth12
+
+ ip netns exec ns2 ip link set lo up
+ ip netns exec ns2 ip link set veth21 up
+ ip netns exec ns2 ip addr add ${rip_v4}/24 dev veth21
+ ip netns exec ns2 ip link set veth20 up
+ ip netns exec ns2 ip addr add ${sip_v4}/24 dev veth20
+}
+
+cleanup() {
+ for i in 0 1 2
+ do
+ ip netns del ns$i > /dev/null 2>&1
+ done
+ pkill nc
+}
+
+server_listen() {
+ ip netns exec ns2 nc -l -p 8080 > "${outfile}" &
+ server_pid=$!
+ sleep 0.2
+}
+
+client_connect() {
+ ip netns exec ns0 timeout 2 nc -w 1 ${vip_v4} ${port} < "${infile}"
+}
+
+verify_data() {
+ wait "${server_pid}"
+ # sha1sum returns two fields [sha1] [filepath]
+ # convert to bash array and access first elem
+ insum=($(sha1sum ${infile}))
+ outsum=($(sha1sum ${outfile}))
+ if [[ "${insum[0]}" != "${outsum[0]}" ]]; then
+ echo "data mismatch"
+ exit 1
+ fi
+}
+
+test_service() {
+ server_listen
+ client_connect
+ ret=$?
+ if [ $ret -ne 0 ]; then
+ return $ret
+ fi
+ verify_data
+}
+
+
+test_dr() {
+ ip netns exec ns0 ip route add ${vip_v4} via ${gip_v4} dev br0
+
+ ip netns exec ns1 sysctl -qw net.ipv4.ip_forward=1
+ ip netns exec ns1 ipvsadm -A -t ${vip_v4}:${port} -s rr
+ ip netns exec ns1 ipvsadm -a -t ${vip_v4}:${port} -r ${rip_v4}:${port}
+ ip netns exec ns1 ip addr add ${vip_v4}/32 dev lo:1
+
+ # avoid incorrect arp response
+ ip netns exec ns2 sysctl -qw net.ipv4.conf.all.arp_ignore=1
+ ip netns exec ns2 sysctl -qw net.ipv4.conf.all.arp_announce=2
+ # avoid reverse route lookup
+ ip netns exec ns2 sysctl -qw net.ipv4.conf.all.rp_filter=0
+ ip netns exec ns2 sysctl -qw net.ipv4.conf.veth21.rp_filter=0
+ ip netns exec ns2 ip addr add ${vip_v4}/32 dev lo:1
+
+ test_service
+}
+
+run_tests() {
+ local errors=
+
+ echo "Testing DR mode..."
+ setup
+ test_dr
+ errors=$(( $errors + $? ))
+
+ return $errors
+}
+
+trap cleanup EXIT
+
+cleanup
+run_tests
+
+if [ $? -ne 0 ]; then
+ echo -e "$(basename $0): ${RED}FAIL${NC}"
+ exit 1
+fi
+echo -e "$(basename $0): ${GREEN}PASS${NC}"
+exit 0
--
1.8.3.1



2019-10-01 18:38:29

by Julian Anastasov

[permalink] [raw]
Subject: Re: [PATCH v3 0/3] selftests: netfilter: introduce test cases for ipvs


Hello,

On Tue, 1 Oct 2019, Haishuang Yan wrote:

> This series patch include test cases for ipvs.
>
> The test topology is who as below:
> +--------------------------------------------------------------+
> | | |
> | ns0 | ns1 |
> | ----------- | ----------- ----------- |
> | | veth01 | --------- | veth10 | | veth12 | |
> | ----------- peer ----------- ----------- |
> | | | | |
> | ----------- | | |
> | | br0 | |----------------- peer |--------------|
> | ----------- | | |
> | | | | |
> | ---------- peer ---------- ----------- |
> | | veth02 | --------- | veth20 | | veth12 | |
> | ---------- | ---------- ----------- |
> | | ns2 |
> | | |
> +--------------------------------------------------------------+
>
> Test results:
> # selftests: netfilter: ipvs.sh
> # Testing DR mode...
> # Testing NAT mode...
> # Testing Tunnel mode...
> # ipvs.sh: PASS
> ok 6 selftests: netfilter: ipvs.sh
>
> Haishuang Yan (3):
> selftests: netfilter: add ipvs test script
> selftests: netfilter: add ipvs nat test case
> selftests: netfilter: add ipvs tunnel test case

Acked-by: Julian Anastasov <[email protected]>

> tools/testing/selftests/netfilter/Makefile | 2 +-
> tools/testing/selftests/netfilter/ipvs.sh | 234 +++++++++++++++++++++++++++++
> 2 files changed, 235 insertions(+), 1 deletion(-)
> create mode 100755 tools/testing/selftests/netfilter/ipvs.sh

Regards

--
Julian Anastasov <[email protected]>

2019-10-02 06:30:09

by Duncan Roe

[permalink] [raw]
Subject: Re: [PATCH v3 0/3] selftests: netfilter: introduce test cases for ipvs

On Tue, Oct 01, 2019 at 09:34:13PM +0300, Julian Anastasov wrote:
>
> Hello,
>
> On Tue, 1 Oct 2019, Haishuang Yan wrote:
>
> > This series patch include test cases for ipvs.
> >
> > The test topology is who as below:
> > +--------------------------------------------------------------+
> > | | |
> > | ns0 | ns1 |
> > | ----------- | ----------- ----------- |
> > | | veth01 | --------- | veth10 | | veth12 | |
> > | ----------- peer ----------- ----------- |
> > | | | | |
> > | ----------- | | |
> > | | br0 | |----------------- peer |--------------|
> > | ----------- | | |
> > | | | | |
> > | ---------- peer ---------- ----------- |
> > | | veth02 | --------- | veth20 | | veth12 | |
> > | ---------- | ---------- ----------- |
> > | | ns2 |
> > | | |
> > +--------------------------------------------------------------+
> >
> > Test results:
> > # selftests: netfilter: ipvs.sh
> > # Testing DR mode...
> > # Testing NAT mode...
> > # Testing Tunnel mode...
> > # ipvs.sh: PASS
> > ok 6 selftests: netfilter: ipvs.sh
> >
> > Haishuang Yan (3):
> > selftests: netfilter: add ipvs test script
> > selftests: netfilter: add ipvs nat test case
> > selftests: netfilter: add ipvs tunnel test case
>
> Acked-by: Julian Anastasov <[email protected]>
>
> > tools/testing/selftests/netfilter/Makefile | 2 +-
> > tools/testing/selftests/netfilter/ipvs.sh | 234 +++++++++++++++++++++++++++++
> > 2 files changed, 235 insertions(+), 1 deletion(-)
> > create mode 100755 tools/testing/selftests/netfilter/ipvs.sh
>
> Regards
>
> --
> Julian Anastasov <[email protected]>

I still prefer #!/bin/sh in 1/3. You never know what's in someone's environment

Cheers ... Duncan.

2019-10-02 08:36:19

by Simon Horman

[permalink] [raw]
Subject: Re: [PATCH v3 0/3] selftests: netfilter: introduce test cases for ipvs

On Wed, Oct 02, 2019 at 11:27:26AM +1000, Duncan Roe wrote:
> On Tue, Oct 01, 2019 at 09:34:13PM +0300, Julian Anastasov wrote:
> >
> > Hello,
> >
> > On Tue, 1 Oct 2019, Haishuang Yan wrote:
> >
> > > This series patch include test cases for ipvs.
> > >
> > > The test topology is who as below:
> > > +--------------------------------------------------------------+
> > > | | |
> > > | ns0 | ns1 |
> > > | ----------- | ----------- ----------- |
> > > | | veth01 | --------- | veth10 | | veth12 | |
> > > | ----------- peer ----------- ----------- |
> > > | | | | |
> > > | ----------- | | |
> > > | | br0 | |----------------- peer |--------------|
> > > | ----------- | | |
> > > | | | | |
> > > | ---------- peer ---------- ----------- |
> > > | | veth02 | --------- | veth20 | | veth12 | |
> > > | ---------- | ---------- ----------- |
> > > | | ns2 |
> > > | | |
> > > +--------------------------------------------------------------+
> > >
> > > Test results:
> > > # selftests: netfilter: ipvs.sh
> > > # Testing DR mode...
> > > # Testing NAT mode...
> > > # Testing Tunnel mode...
> > > # ipvs.sh: PASS
> > > ok 6 selftests: netfilter: ipvs.sh
> > >
> > > Haishuang Yan (3):
> > > selftests: netfilter: add ipvs test script
> > > selftests: netfilter: add ipvs nat test case
> > > selftests: netfilter: add ipvs tunnel test case
> >
> > Acked-by: Julian Anastasov <[email protected]>
> >
> > > tools/testing/selftests/netfilter/Makefile | 2 +-
> > > tools/testing/selftests/netfilter/ipvs.sh | 234 +++++++++++++++++++++++++++++
> > > 2 files changed, 235 insertions(+), 1 deletion(-)
> > > create mode 100755 tools/testing/selftests/netfilter/ipvs.sh
> >
> > Regards
> >
> > --
> > Julian Anastasov <[email protected]>
>
> I still prefer #!/bin/sh in 1/3. You never know what's in someone's environment

That would be my preference too.

2019-10-04 12:05:55

by Duncan Roe

[permalink] [raw]
Subject: Re: [PATCH v3 0/3] selftests: netfilter: introduce test cases for ipvs

On Thu, Oct 03, 2019 at 10:41:06PM +0800, Haishuang Yan wrote:
>
>
> > On 2019??10??2??, at ????9:27, Duncan Roe <[email protected]> wrote:
> >
> > On Tue, Oct 01, 2019 at 09:34:13PM +0300, Julian Anastasov wrote:
> >>
> >> Hello,
> >>
> >> On Tue, 1 Oct 2019, Haishuang Yan wrote:
> >>
> >>> This series patch include test cases for ipvs.
> >>>
> >>> The test topology is who as below:
> >>> +--------------------------------------------------------------+
> >>> | | |
> >>> | ns0 | ns1 |
> >>> | ----------- | ----------- ----------- |
> >>> | | veth01 | --------- | veth10 | | veth12 | |
> >>> | ----------- peer ----------- ----------- |
> >>> | | | | |
> >>> | ----------- | | |
> >>> | | br0 | |----------------- peer |--------------|
> >>> | ----------- | | |
> >>> | | | | |
> >>> | ---------- peer ---------- ----------- |
> >>> | | veth02 | --------- | veth20 | | veth12 | |
> >>> | ---------- | ---------- ----------- |
> >>> | | ns2 |
> >>> | | |
> >>> +--------------------------------------------------------------+
> >>>
> >>> Test results:
> >>> # selftests: netfilter: ipvs.sh
> >>> # Testing DR mode...
> >>> # Testing NAT mode...
> >>> # Testing Tunnel mode...
> >>> # ipvs.sh: PASS
> >>> ok 6 selftests: netfilter: ipvs.sh
> >>>
> >>> Haishuang Yan (3):
> >>> selftests: netfilter: add ipvs test script
> >>> selftests: netfilter: add ipvs nat test case
> >>> selftests: netfilter: add ipvs tunnel test case
> >>
> >> Acked-by: Julian Anastasov <[email protected]>
> >>
> >>> tools/testing/selftests/netfilter/Makefile | 2 +-
> >>> tools/testing/selftests/netfilter/ipvs.sh | 234 +++++++++++++++++++++++++++++
> >>> 2 files changed, 235 insertions(+), 1 deletion(-)
> >>> create mode 100755 tools/testing/selftests/netfilter/ipvs.sh
> >>
> >> Regards
> >>
> >> --
> >> Julian Anastasov <[email protected]>
> >
> > I still prefer #!/bin/sh in 1/3. You never know what's in someone's environment
> >
> > Cheers ... Duncan.
> >
>
> It??s also my preference too. "_"
>
> I have tested both #!/bin/bash and #!/bin/sh script, they all works properly.

Enter these 2 lines:
> ip(){ return 0; }
> export -f ip

Now try the #!/bin/bash script. If that now fails, try again with #!/bin/bash
changed to #!/bin/bash -p

Any better now?

Cheers ... Duncan.

2019-10-05 01:07:18

by Haishuang Yan

[permalink] [raw]
Subject: Re: [PATCH v3 0/3] selftests: netfilter: introduce test cases for ipvs


> On 2019??10??4??, at ????7:47, Duncan Roe <[email protected]> wrote:
>
> On Thu, Oct 03, 2019 at 10:41:06PM +0800, Haishuang Yan wrote:
>>
>>
>>> On 2019??10??2??, at ????9:27, Duncan Roe <[email protected]> wrote:
>>>
>>> On Tue, Oct 01, 2019 at 09:34:13PM +0300, Julian Anastasov wrote:
>>>>
>>>> Hello,
>>>>
>>>> On Tue, 1 Oct 2019, Haishuang Yan wrote:
>>>>
>>>>> This series patch include test cases for ipvs.
>>>>>
>>>>> The test topology is who as below:
>>>>> +--------------------------------------------------------------+
>>>>> | | |
>>>>> | ns0 | ns1 |
>>>>> | ----------- | ----------- ----------- |
>>>>> | | veth01 | --------- | veth10 | | veth12 | |
>>>>> | ----------- peer ----------- ----------- |
>>>>> | | | | |
>>>>> | ----------- | | |
>>>>> | | br0 | |----------------- peer |--------------|
>>>>> | ----------- | | |
>>>>> | | | | |
>>>>> | ---------- peer ---------- ----------- |
>>>>> | | veth02 | --------- | veth20 | | veth12 | |
>>>>> | ---------- | ---------- ----------- |
>>>>> | | ns2 |
>>>>> | | |
>>>>> +--------------------------------------------------------------+
>>>>>
>>>>> Test results:
>>>>> # selftests: netfilter: ipvs.sh
>>>>> # Testing DR mode...
>>>>> # Testing NAT mode...
>>>>> # Testing Tunnel mode...
>>>>> # ipvs.sh: PASS
>>>>> ok 6 selftests: netfilter: ipvs.sh
>>>>>
>>>>> Haishuang Yan (3):
>>>>> selftests: netfilter: add ipvs test script
>>>>> selftests: netfilter: add ipvs nat test case
>>>>> selftests: netfilter: add ipvs tunnel test case
>>>>
>>>> Acked-by: Julian Anastasov <[email protected]>
>>>>
>>>>> tools/testing/selftests/netfilter/Makefile | 2 +-
>>>>> tools/testing/selftests/netfilter/ipvs.sh | 234 +++++++++++++++++++++++++++++
>>>>> 2 files changed, 235 insertions(+), 1 deletion(-)
>>>>> create mode 100755 tools/testing/selftests/netfilter/ipvs.sh
>>>>
>>>> Regards
>>>>
>>>> --
>>>> Julian Anastasov <[email protected]>
>>>
>>> I still prefer #!/bin/sh in 1/3. You never know what's in someone's environment
>>>
>>> Cheers ... Duncan.
>>>
>>
>> It??s also my preference too. "_"
>>
>> I have tested both #!/bin/bash and #!/bin/sh script, they all works properly.
>
> Enter these 2 lines:
>> ip(){ return 0; }
>> export -f ip
>
> Now try the #!/bin/bash script. If that now fails, try again with #!/bin/bash
> changed to #!/bin/bash -p
>
> Any better now?
>
> Cheers ... Duncan.
>
It??s better now, thanks for your explanation.
In v3 commit I will use #!/bin/bash -p to prevent exporting function from environment variables.